/**
******************************************************************************
* @file         ping.c
* @version      V1.0
* @date         2020-06-05
* @brief        ICMPЭ飬PINGIPַ
*
* @company      Ƽ޹˾
* @information  WIZnet W5500ٷ̣ȫ̼֧֣۸ƴ
* @website      www.wisioe.com
* @forum        www.w5500.cn
* @qqGroup      579842114
* @Support      QQ:2571856470Mob:18998931307
* @Email        support@wisioe.com
******************************************************************************
*/
#include "ping.h"
  
#define PING_DEBUG
PINGMSGR PingRequest;   
PINGMSGR PingReply;     

static uint16 RandomID = 0x1234; 
static uint16 RandomSeqNum = 0x4321;
uint8 ping_reply_received = 0; 
uint8 req=0;
uint8 rep=0;

/**
*@brief  ԶPINGIP
*@param  ssocket number
*@param  addrIPַ
*@return 
*/

void ping_auto(uint8 s, uint8 *addr)
{
  uint8 i;
  int32_t len = 0;
  uint8 cnt=0;
  for(i = 0; i< 4;i++)                                      /*ѭping3*/
  {
    delay_ms(10); 
    switch(getSn_SR(s))                                     /*ȡsocket״*/
    {
      case SOCK_CLOSED:                                     /*socketر״̬*/
        close(s);
        IINCHIP_WRITE(Sn_PROTO(s), IPPROTO_ICMP);           /*ICMP Э*/
        if(socket(s,Sn_MR_IPRAW,3000,0)!=0)                 /*жip rawģʽsocketǷ*/
        {}
        while(getSn_SR(s)!=SOCK_IPRAW);
        delay_ms(1000);                                     /*ȴ 1000ms*/
        delay_ms(1000);                                     /*ȴ 1000ms*/
      break;
        
      case SOCK_IPRAW:                                      /*ip rawģʽ*/
        ping_request(s, addr);                              /*Ping*/
        req++;
        while(1)
        {  
          if ( (len = getSn_RX_RSR(s) ) > 0)
          {
            ping_reply(s, addr, len);                       /*ȡظϢ*/
            delay_ms(50);                                   /*wait 50ms*/
            rep++;
            break;
          }
          else if(cnt > 200)
          {
            printf( "Request Time out. \r\n");
            cnt = 0;
            break;
          }
          else
          {
            cnt++;
            delay_ms(50);                                   /*wait 50ms*/
          }
          // wait_time for 2 seconds, Break on fail
        }
  
      break;
      default:
      break;
    }
      #ifdef PING_DEBUG
    if(rep!=0)
    {
      printf("Ping Request = %d, PING_Reply = %d\r\n",req,rep);
      if(rep == req)
        printf( "PING SUCCESS\r\n " );
      else
        printf( "REPLY_ERROR\r\n " );
    }  
    else{}    
      #endif  
  }
}

/**
*@brief  趨pingIP
*@param  s-   socket number
*@param  addr-  IPַ
*@param  pCount- pingĴ
*@return 
*/
void ping_count(uint8 s, uint16 pCount, uint8 *addr)
{
  uint16 rlen, cnt,i;
  cnt = 0;
  
  for(i=0; i<pCount+1;i++)                                   /*ѭping pCount*/
  {

    if(i!=0)
    {
      /* Output count number */
      printf( "\r\nNo.%d\r\n",   (i-1));
    }
    switch(getSn_SR(s))                                      /*ȡsocket״̬*/
    {
      case SOCK_CLOSED:                                      /*socketر״̬*/
        close(s); 
        /* Create Socket */  
        IINCHIP_WRITE(Sn_PROTO(s), IPPROTO_ICMP);            /*ICMP Э*/
        /* Check socket register */
        while(getSn_SR(s)!=SOCK_IPRAW);    
        delay_ms(1000);                                      /*ȴ 1000ms*/
        delay_ms(1000);                                      /*ȴ 1000ms*/
      break;
      
      case SOCK_IPRAW:                                       /*ip rawģʽ*/
        ping_request(s, addr);                               /*Ping*/
        req++;      
        while(1)
        {
          if ( (rlen = getSn_RX_RSR(s) ) > 0)
          {
            ping_reply(s, addr, rlen);                       /*ȡظϢ*/
            rep++;
            if (ping_reply_received)  break;        
          }    
          if ( (cnt > 100) ) 
          {
            printf( "\r\nRequest Time out. \r\n") ;
            cnt = 0;
            break;
          }
          else 
          { 
            cnt++;   
            delay_ms(50);                                    /*wait 50ms*/
          }
        }
      break;
        
      default:    
        break;
    }
    if(req>=pCount)
    {  
      #ifdef PING_DEBUG
      printf("Ping Request = %d, PING_Reply = %d\r\n",req,rep);
      if(rep == req)
        printf( "PING SUCCESS\r\n " );
      else
        printf( "REPLY_ERROR\r\n " );  
      #endif  
    }
  }
}

/**
*@brief  pingӦ
*@param  s-  socket number
*@param  addr-  Pַ
*@return 
*/
uint8 ping_request(uint8 s, uint8 *addr)
{
  uint16 i;
  int32_t t;
  ping_reply_received = 0;                                   /*ping ظʼ־λ*/
  PingRequest.Type = PING_REQUEST;                           /*Ping-Request*/
  PingRequest.Code = CODE_ZERO;                              /* '0'*/
  PingRequest.ID = htons(RandomID++);                        /*pingӦIDΪͱ*/
  PingRequest.SeqNum =htons(RandomSeqNum++);                 /*pingӦкΪα*/
  for(i = 0 ; i < BUF_LEN; i++)
  {                                  
    PingRequest.Data[i] = (i) % 8;                           /*pingӦ'0'~'8*/
  }
  PingRequest.CheckSum = 0;
  /* Ӧ*/
  PingRequest.CheckSum = htons(checksum((uint8*)&PingRequest,sizeof(PingRequest))); 
  /*pingӦĿķ */
  t = sendto(s,(uint8 *)&PingRequest,sizeof(PingRequest),addr,3000);
  if(t==0)  
  {  
    printf( "\r\n Fail to send ping-reply packet  r\n") ;          
  }
  else
  {
    printf("  Ping %d.%d.%d.%d  \r\n",(addr[0]),  (addr[1]),  (addr[2]),  (addr[3]));
  }
  return 0;
} 

/**
*@brief  Pingظ
*@param  s-  socket number
*@param  addr- Pingַ
*@return 
*/
uint8 ping_reply(uint8 s, uint8 *addr,  uint16 rlen)
{
  uint16 tmp_checksum;
  uint16 len;
  uint16 i;
  uint8 data_buf[128];
  
  uint16 port = 3000;
  PINGMSGR PingReply;
  len = recvfrom(s, (uint8 *)data_buf,rlen,addr,&port);      /*ĿĶ˽*/
  if(data_buf[0] == PING_REPLY) 
  {
    PingReply.Type      = data_buf[0];
    PingReply.Code      = data_buf[1];
    PingReply.CheckSum   = (data_buf[3]<<8) + data_buf[2];
    PingReply.ID      = (data_buf[5]<<8) + data_buf[4];
    PingReply.SeqNum    = (data_buf[7]<<8) + data_buf[6];
    
    for(i=0; i<len-8 ; i++)
    {
      PingReply.Data[i] = data_buf[8+i];
    }
    tmp_checksum = ~checksum(data_buf,len);                  /*pingظĴ*/
    if(tmp_checksum != 0xffff)
      printf("tmp_checksum = %x\r\n",tmp_checksum);
    else
    {
      printf("  %d.%d.%d.%d Ļظ ID=%x ֽ=%d \r\n",
      (addr[0]),  (addr[1]),  (addr[2]),  (addr[3]),htons(PingReply.ID),(rlen+6));      
      ping_reply_received =1;                                /*˳pingظѭʱpingظ־Ϊ1*/
    }
  }
  else if(data_buf[0] == PING_REQUEST)
  {
    PingReply.Code    = data_buf[1];
    PingReply.Type    = data_buf[2];
    PingReply.CheckSum  = (data_buf[3]<<8) + data_buf[2];
    PingReply.ID      = (data_buf[5]<<8) + data_buf[4];
    PingReply.SeqNum    = (data_buf[7]<<8) + data_buf[6];    
    for(i=0; i<len-8 ; i++)
    {
      PingReply.Data[i] = data_buf[8+i];
    }
    tmp_checksum = PingReply.CheckSum;                      /*pingظ*/
    PingReply.CheckSum = 0;
    if(tmp_checksum != PingReply.CheckSum)
    {
      printf( " \n CheckSum is in correct %x shold be %x \n",   (tmp_checksum),  htons(PingReply.CheckSum)) ;
    }
    else
    {    }
      printf("  Request from %d.%d.%d.%d  ID:%x SeqNum:%x  :data size %d bytes\r\n",
        (addr[0]),  (addr[1]),  (addr[2]),  (addr[3]),  (PingReply.ID),  (PingReply.SeqNum),  (rlen+6) );     
      ping_reply_received =1;                                /* ˳pingظѭʱpingظ־Ϊ1  */
  }
  else
  {      
    printf(" Unkonwn msg. \n");
  }
  return 0;
}

/**
*@brief  ִping
*@param  
*@return 
*/
void do_ping(void)
{   
  printf("------------PING_TEST_START-----------------------\r\n");
  delay_ms(1000); // wait 1000ms
  ping_auto(SOCK_PING,remote_ip);
}
